import { Option } from './option';
import { IOption } from './option.interface';
export declare class OptionList {
    private _options;
    private _selectedOptions;
    private _highlightedOption;
    private _hasShown;
    private _hasSelected;
    private _guid;
    readonly hasShown: boolean;
    readonly hasSelected: boolean;
    readonly Guid: string;
    constructor(options: Array<IOption>);
    /** Options. **/
    readonly options: Array<Option>;
    getOptionsByValue(value: string): Array<Option>;
    /** Selected Options. **/
    readonly selectedOptions: Array<Option>;
    /** Value. **/
    value: Array<IOption>;
    /** Selection. **/
    readonly selection: Array<Option>;
    addNewlyCreatedOption(option: Option, multiple: boolean): void;
    select(option: Option, multiple: boolean): void;
    deselect(option: Option): void;
    clearSelection(): void;
    reorderSelected(v: Array<string>): void;
    private updateHasSelected();
    /** Filter. **/
    readonly filtered: Array<Option>;
    readonly filteredEnabled: Array<Option>;
    filter(term: string): boolean;
    private resetFilter();
    /** Highlight. **/
    readonly highlightedOption: Option;
    highlight(): void;
    highlightOption(option: Option): void;
    highlightNextOption(): void;
    highlightPreviousOption(): void;
    private clearHighlightedOption();
    private getHighlightedIndexFromList(options);
    getHighlightedIndex(): number;
    /** Util. **/
    hasShownSelected(): boolean;
    private getFirstShown();
    private getFirstShownSelected();
    isNewlyCreated(option: Option): boolean;
    static equalValues(v0: Array<string>, v1: Array<string>): boolean;
    static newGuid(): string;
}
